<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

/**
 * Settings Page Notification Tab
 *
 * The code for the plugins settings page notification tab
 *
 * @package Follow My Blog Post
 * @since 1.0.0
 */

?>
<!-- beginning of the notification settings meta box -->
<div id="wpw-fp-notification" class="post-box-container">
	<div class="metabox-holder">	
		<div class="meta-box-sortables ui-sortable">
			<div id="notification" class="postbox">	
				<div class="handlediv" title="<?php esc_html_e( 'Click to toggle', 'wpwfp' ); ?>"><br /></div>

					<!-- notification settings box title -->
					<h3 class="hndle">
						<span style='vertical-align: top;'><?php esc_html_e( 'Notification Settings', 'wpwfp' ); ?></span>
					</h3>

					<div class="inside">
					
						<table class="form-table">
							<tbody>
							
								<tr>
									<td colspan="2">
										<?php
											echo apply_filters ( 'wpweb_fb_settings_submit_button', '<input class="button-primary wpw-fp-save-btn" type="submit" name="wpw-fp-set-submit" value="'.esc_html__( 'Save Changes','wpwfp' ).'" />' );
										?>
									</td>
								</tr>
								
								<?php
								
									// do action for add setting before notification settings
									do_action( 'wpw_fp_before_notification_setting', $wpw_fp_options );
									
								?>
			
								<tr valign="top">
									<th scope="row">
										<label for="wpw_fp_options[notification_type]"><?php esc_html_e( 'Send Emails for', 'wpwfp' ); ?></label>
									</th>
									<td>
										<ul class="wpw_fp_indvisual" id="wpw_fp_indvisual">
										<?php 
											$all_types = get_post_types( array( 'public' => true ), 'objects');
											$all_types = is_array( $all_types ) ? $all_types : array();
											unset( $all_types['attachment'] );
											
											if( !empty( $wpw_fp_options['notification_type'] ) ) {
												$notification_types = $wpw_fp_options['notification_type'];
											} else {
												$notification_types = '';
											}
															
											$notification_types = is_array( $notification_types ) ? $notification_types : array();
														
											foreach ( $all_types as $type ) {
												if( !empty( $wpw_fp_options['notification_item_'.$type->name] ) ) {
													$items_count = count( $wpw_fp_options['notification_item_'.$type->name] );
												} else {
													$wpw_fp_options['notification_item_'.$type->name] = '';
													$items_count = 0;
												}
															
												if ( !is_object( $type ) ) continue;															
													$label = $type->labels->name ? $type->labels->name : $type->name;
													$selected = ( in_array( $type->name, $notification_types ) ) ? 'checked="checked"' : '';
																	
													$individual = '<a href="javascript:void(0);" class="wpw_fp_indivisual_entries" onclick="wpw_fp_popup_indivisual( \'' . $type->name . '\', \'notification\' )">' . esc_html__( 'Choose individual entries', 'wpwfp' ) . '</a>';
										?>
											
											<li>
												<input type="checkbox" id="wpw_fp_notification_<?php echo $type->name; ?>" name="wpw_fp_options[notification_type][]" value="<?php echo $type->name; ?>" <?php echo $selected; ?>/>
																						
												<label for="wpw_fp_notification_<?php echo $type->name; ?>"><?php echo $label; ?></label>
													<?php echo $individual; ?>&nbsp;&nbsp;&nbsp;<label id="wpw_fp_selected_indivisual_notification_<?php echo $type->name; ?>"><?php echo '( ' . $items_count . ' ) ';?><?php esc_html_e( 'Selected', 'wpwfp' ); ?></label>
											</li>
											
										<?php 	$args = array( 'post_type' => $type->name, 'posts_per_page' => '-1' );
												$wp_query = null;
												$wp_query = new WP_Query;
												$wp_query->query( $args );
												
												if( !empty( $wpw_fp_options['notification_item_'.$type->name] ) ) {
													$notification_items = $wpw_fp_options['notification_item_'.$type->name];
												} else {
													$notification_items = '';
												}
															
												$notification_items = is_array( $notification_items ) ? $notification_items : array();
										?>
																																			
												<!-- listing all post related post -->
												<div id="fp_indivisual_data_notification_<?php echo $type->name; ?>" class="wpw_fp_indivisual_entries_data" style="display:none;">
													<div class="wpw_fp_indivisual_header">
														<div class="wpw_fp_indivisual_title">
															<h2><?php echo $label; ?></h2>
														</div>
																								
														<div class="wpw_fp_indivisual_submit" >
																									
																<a href="javascript:void(0);" class="wpw_fp_checkall_entries" onclick="wpw_fp_toggle_check_uncheck_all('<?php echo $type->name;?>', 'notification', 1);"><?php esc_html_e( 'Check all', 'wpwfp' ); ?></a>&nbsp;&nbsp;&nbsp;<a href="javascript:void(0);" class="wpw_fp_uncheckall_entries" onclick="wpw_fp_toggle_check_uncheck_all('<?php echo $type->name;?>', 'notification', 0);"><?php esc_html_e( 'Uncheck all', 'wpwfp' ); ?></a>&nbsp;&nbsp;&nbsp;
																												
																<?php //} ?>
																					
																<input type="submit" value="<?php esc_html_e( 'Done', 'wpwfp' ); ?>" id="wpw_fp_set_submit_indivisual" class="button-primary">
														</div><!-- .wpw_fp_indivisual_submit -->					
													</div><!-- .wpw_fp_indivisual_header -->
																							
													<?php 	echo '<ul>';
														
															if ( $wp_query->have_posts() ) {
															while ( $wp_query->have_posts() ) { $wp_query->the_post();
																											
																$checked = ( in_array( $wp_query->post->ID, $notification_items ) ) ? 'checked="checked"' : '';
																$posttitle = !empty( $wp_query->post->post_title ) ? $wp_query->post->post_title : esc_html__( '(no title)', 'wpwfp' );
																	if( strlen( $posttitle ) > 50 ) {
																		$posttitle = substr( $posttitle, 0, 50 );
																		$posttitle = $posttitle.'...';
																	} else {
																		$posttitle = $posttitle;
																	}
													?>
																										
														<li>
															<input type="checkbox" id="wpw_fp_notification_<?php echo $wp_query->post->ID; ?>" name="wpw_fp_options[notification_item_<?php echo $type->name; ?>][]" value="<?php echo $wp_query->post->ID; ?>" <?php echo $checked; ?> />
																											
															<label for="wpw_fp_notification_<?php echo $wp_query->post->ID;?>"><?php echo $posttitle; ?></label>
														</li>
														
													<?php	} 
													} else { ?>
														<li><?php esc_attr_e( 'No Entries for this type.', 'wpwfp' ); ?></li>
												<?php	} ?>
													<?php wp_reset_query(); ?>
																											
													<?php echo '</ul>'; ?>
																						
												</div><!--fp_indivisual_data_-->
											<?php	} ?>
										</ul>
										<span class="description"><?php echo esc_html__( 'Check each of the post types for which you want the follows should receive an email when any post is created/updated. You will see a list of all available content types from your site. If you click on the checkbox beside a content type, this means when any post of selected post type gets updated, all followers of that post will get a notification email. Click on', 'wpwfp').' "'.esc_html__( 'choose individual entries', 'wpwfp').'" '.esc_html__( 'and a pop up window will appear from which you can select individual posts for which notification emails will be sent to followers.', 'wpwfp' ); ?></span>
									</td>
								</tr>
								
								<tr>
									<th scope="row">
										<label for="wpw_fp_options[double_opt_in]"><?php esc_html_e('Require Email Confirmation for Registered users', 'wpwfp');?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[double_opt_in]" name="wpw_fp_options[double_opt_in]" value="1" <?php checked( '1', isset( $wpw_fp_options['double_opt_in'] ) ? $wpw_fp_options['double_opt_in'] : '' ) ?>/><br />
										<span class="description"><?php echo esc_html__( 'When checked, Registered users will be sent a confirmation email to subscribe, and will only be added once they confirmed the subscription.', 'wpwfp'); ?></span>
									</td>
								</tr>
								
								<tr>
									<th scope="row">
										<label for="wpw_fp_options[double_opt_in_guest]"><?php esc_html_e('Require Email Confirmation for Guest users', 'wpwfp');?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[double_opt_in_guest]" name="wpw_fp_options[double_opt_in_guest]" value="1" <?php checked( '1', isset( $wpw_fp_options['double_opt_in_guest'] ) ? $wpw_fp_options['double_opt_in_guest'] : '' ) ?>/><br />
										<span class="description"><?php echo esc_html__( 'When checked, Guest users will be sent a confirmation email to subscribe, and will only be added once they confirmed the subscription.', 'wpwfp'); ?></span>
									</td>
								</tr>								
								
								<tr>
									<th scope="row">
										<label for="wpw_fp_options[recipient_per_email]"><?php esc_html_e('Recipients Per Email', 'wpwfp');?></label>
									</th>
									<td>
										<input type="text" id="wpw_fp_options[recipient_per_email]" name="wpw_fp_options[recipient_per_email]" value="<?php echo $wpw_fp_model->wpw_fp_escape_attr( $wpw_fp_options['recipient_per_email'] ); ?>" class="small-text recipient_per_email" /><br />
										<span class="description"><?php esc_html_e( 'Restrict the number of recipients per email. Leave it 0 for unlimited.', 'wpwfp' ); ?></span>
									</td>
								</tr>
								<?php
									$unsubscribe_option = '';
									// check for disable unsubscribe confirmation option hide or show
									if($wpw_fp_options['recipient_per_email'] != 1) {
										$unsubscribe_option = ' style="display:none"';
									}
								?>
								<tr class="unsubscribe-confirmation-link" <?php print $unsubscribe_option;?>>
									<th scope="row">
										<label for="wpw_fp_options[unsubscribe_confirmation]"><?php esc_html_e( 'Disable Unsubscribe Confirmation', 'wpwfp' );?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[unsubscribe_confirmation]" name="wpw_fp_options[unsubscribe_confirmation]" value="1" <?php checked( '1', isset( $wpw_fp_options['unsubscribe_confirmation'] ) ? $wpw_fp_options['unsubscribe_confirmation'] : '' ) ?> class="unsubscribe_confirmation" /><br />
										<span class="description"><?php echo esc_html__( 'When checked, Subscribers will get direct unsubscribe link instead getting confirmation email to unsubscribe.', 'wpwfp' ); ?></span>
									</td>
								</tr>
								<?php
									$is_individual_unsubscribe = '';
									
									// check for disable unsubscribe confirmation option hide or show
									if( !isset( $wpw_fp_options['unsubscribe_confirmation'] ) || ( isset( $wpw_fp_options['unsubscribe_confirmation'] ) && $wpw_fp_options['unsubscribe_confirmation'] != 1 ) ) {
										$is_individual_unsubscribe = ' style="display:none"';
									}
								?>
								<tr class="individual-unsubscribe" <?php print $is_individual_unsubscribe;?>>
									<th scope="row">
										<label for="wpw_fp_options[is_individual_unsubscribe]"><?php esc_html_e( 'Enable Individual unsubscribe Link', 'wpwfp' );?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[is_individual_unsubscribe]" name="wpw_fp_options[is_individual_unsubscribe]" value="1" <?php checked( '1', isset( $wpw_fp_options['is_individual_unsubscribe'] ) ? $wpw_fp_options['is_individual_unsubscribe'] : '' ) ?> class="is_individual_unsubscribe" /><br />
										<span class="description"><?php echo esc_html__( 'When checked, Subscribers will get individual unsubscribe link for unsubscribing from particular post, term and author.', 'wpwfp' ); ?></span>
									</td>
								</tr>
								
								<!-- Posts Notification Events Start -->
								<tr>
									<th colspan="2">
										<h3><?php esc_html_e( 'Posts Notification Events', 'wpwfp' ); ?></h3>
									</th>
								</tr>
								
								<tr>
									<th scope="row">
										<label for="wpw_fp_options[post_trigger_notification]"><?php esc_html_e('Trigger Emails', 'wpwfp');?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[post_trigger_notification][post_update]" name="wpw_fp_options[post_trigger_notification][post_update]" value="1" <?php checked( '1', isset( $wpw_fp_options['post_trigger_notification']['post_update'] ) ? $wpw_fp_options['post_trigger_notification']['post_update'] : '' ) ?>/>
										<label for="wpw_fp_options[post_trigger_notification][post_update]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When post / page updated', 'wpwfp' );?></label><br />
										<input type="checkbox" id="wpw_fp_options[post_trigger_notification][new_comment]" name="wpw_fp_options[post_trigger_notification][new_comment]" value="1" <?php checked( '1', isset( $wpw_fp_options['post_trigger_notification']['new_comment'] ) ? $wpw_fp_options['post_trigger_notification']['new_comment'] : '' ) ?>/>
										<label for="wpw_fp_options[post_trigger_notification][new_comment]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When new comment added', 'wpwfp' );?></label><br />
										<span class="description"><?php echo sprintf(
											esc_html__( 'With a Trigger Emails, you can automatically send emails at specified event performed.%s Note: %s You must check  %s Notify followers for this update %s setting at post/page level if you want to send an email to followers when post/page gets updated.', 'wpwfp' ),
											'<br><b>', "</b>", "<b>", "</b>"
											);?></span>
									</td>
								</tr>
								<!-- Posts Notification Events End -->
								
								<!-- Terms Notification Events Start -->
								<tr>
									<th colspan="2">
										<h3><?php esc_html_e( 'Terms Notification Events', 'wpwfp' ); ?></h3>
									</th>
								</tr>
								
								<tr>
									<th scope="row">
										<label for="wpw_fp_options[term_trigger_notification]"><?php esc_html_e('Trigger Emails', 'wpwfp');?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[term_trigger_notification][new_post]" name="wpw_fp_options[term_trigger_notification][new_post]" value="1" <?php checked( '1', isset( $wpw_fp_options['term_trigger_notification']['new_post'] ) ? $wpw_fp_options['term_trigger_notification']['new_post'] : '' ) ?>/>
										<label for="wpw_fp_options[term_trigger_notification][new_post]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When new post published', 'wpwfp' );?></label><br />
										<input type="checkbox" id="wpw_fp_options[term_trigger_notification][post_update]" name="wpw_fp_options[term_trigger_notification][post_update]" value="1" <?php checked( '1', isset( $wpw_fp_options['term_trigger_notification']['post_update'] ) ? $wpw_fp_options['term_trigger_notification']['post_update'] : '' ) ?>/>
										<label for="wpw_fp_options[term_trigger_notification][post_update]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When post / page updated', 'wpwfp' );?></label><br />
										<input type="checkbox" id="wpw_fp_options[term_trigger_notification][new_comment]" name="wpw_fp_options[term_trigger_notification][new_comment]" value="1" <?php checked( '1', isset( $wpw_fp_options['term_trigger_notification']['new_comment'] ) ? $wpw_fp_options['term_trigger_notification']['new_comment'] : '' ) ?>/>
										<label for="wpw_fp_options[term_trigger_notification][new_comment]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When new comment added', 'wpwfp' );?></label><br />
										<span class="description"><?php echo sprintf(
											esc_html__( 'With a Trigger Emails, you can automatically send emails at specified event performed.%s Note: %s You must check %s Notify followers for this update %s setting at post/page level if you want to send an email to followers when post/page gets updated.', 'wpwfp' ),
											"<br><b>", "</b>", "<b>", "</b>"
											);?></span>
									</td>
								</tr>
								<!-- Terms Notification Events End -->
								
								<!-- Authors Notification Events Start -->
								<tr>
									<th colspan="2">
										<h3><?php esc_html_e( 'Authors Notification Events', 'wpwfp' ); ?></h3>
									</th>
								</tr>
								
								<tr>
									<th scope="row">
										<label for="wpw_fp_options[author_trigger_notification]"><?php esc_html_e('Trigger Emails', 'wpwfp');?></label>
									</th>
									<td>
										<input type="checkbox" id="wpw_fp_options[author_trigger_notification][new_post]" name="wpw_fp_options[author_trigger_notification][new_post]" value="1" <?php checked( '1', isset( $wpw_fp_options['author_trigger_notification']['new_post'] ) ? $wpw_fp_options['author_trigger_notification']['new_post'] : '' ) ?>/>
										<label for="wpw_fp_options[author_trigger_notification][new_post]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When new post published', 'wpwfp' );?></label><br />
										<input type="checkbox" id="wpw_fp_options[author_trigger_notification][post_update]" name="wpw_fp_options[author_trigger_notification][post_update]" value="1" <?php checked( '1', isset( $wpw_fp_options['author_trigger_notification']['post_update'] ) ? $wpw_fp_options['author_trigger_notification']['post_update'] : '' ) ?>/>
										<label for="wpw_fp_options[author_trigger_notification][post_update]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When post / page updated', 'wpwfp' );?></label><br />
										<input type="checkbox" id="wpw_fp_options[author_trigger_notification][new_comment]" name="wpw_fp_options[author_trigger_notification][new_comment]" value="1" <?php checked( '1', isset( $wpw_fp_options['author_trigger_notification']['new_comment'] ) ? $wpw_fp_options['author_trigger_notification']['new_comment'] : '' ) ?>/>
										<label for="wpw_fp_options[author_trigger_notification][new_comment]" class="wpw-fp-checkbox-label"><?php esc_html_e( 'When new comment added', 'wpwfp' );?></label><br />
										<span class="description"><?php echo sprintf(esc_html__( 'With a Trigger Emails, you can automatically send emails at specified event performed. %s Note: %s You must check %s Notify followers for this update %s setting at post/page level if you want to send an email to followers when post/page gets updated.', 'wpwfp' ),
										"<br><b>", "</b>", "<b>", "</b>"
									);?></span>
									</td>
								</tr>
								<!-- Authors Notification Events End -->
								
								<?php
									// do action for add setting after notification settings
									do_action( 'wpw_fp_after_notification_setting', $wpw_fp_options );
								?>
								
								<tr>
									<td colspan="2">
										<?php
											echo apply_filters ( 'wpweb_fb_settings_submit_button', '<input class="button-primary wpw-fp-save-btn" type="submit" name="wpw-fp-set-submit" value="'.esc_html__( 'Save Changes','wpwfp' ).'" />' );
										?>
									</td>
								</tr>
							</tbody>
						</table>
					 
				</div><!-- .inside -->
			</div><!-- #notification -->
		</div><!-- .meta-box-sortables ui-sortable -->
	</div><!-- .metabox-holder -->
</div><!-- #wpw-fp-notification -->