<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

/**
 * Followed My Blog Post Extensions
 *
 * The html markup for the plugin extensions list
 * 
 * @package Follow My Blog Post
 * @since 1.8.0
 */
?>

<div class="wrap">

    <div class="wpw-fp-extension-main-title">
        <!-- wpweb logo -->
        <img src="<?php echo esc_url(WPW_FP_IMG_URL) . '/wpweb-logo.png'; ?>" class="wpweb-logo" alt="<?php esc_html_e( 'WP Web Logo', 'wpwfp' );?>" />
        <!-- plugin name -->
        <h2><?php esc_html_e( 'Follow My Blog Post - Extensions', 'wpwfp' ); ?></h2>
    </div>
    <p><?php esc_html_e( 'The following are  available extensions to extend Follow My Blog Post functionality.', 'wpwfp' ); ?></p><br />

        <!-- beginning of the content section -->
        <div class="content wpw-fp-content-section">

            <!--beginning of extensions main-->
             <div class="wpw-fp-extensions-main">

             <?php
                    /**
                     * Fires follow my blog post extensions box before.
                     * 
                     * @package Follow My Blog Post
                     * @since 1.8.0
                     */
                    do_action( 'wpw_fp_extensions_box_before', '' );
                ?>

                <div class="wpw-fp-available-extensions-inner-box wpw-fp-schedule-emails">
                    <img class="wpw-fp-extensions-thumbnail" alt="Extensions Image" src="<?php echo esc_url(WPW_FP_IMG_URL) . '/wpweb-schedule-emails.png'; ?>">
                    <h3><?php esc_html_e( 'Follow My Blog Post – Schedule Emails Extension', 'wpwfp' ); ?></h3>
                    <p><?php printf( esc_html__( 'With the %sSchedule Emails Extension%s for the Follow My Blog Post Plugin you can schedule your emails hourly, daily, twice daily or weekly.', 'wpwfp' ), '<strong>','</strong>'); ?></p>
                    <span class="wpw-fp-action-links"><a target="_blank" href="http://codecanyon.net/item/schedule-emails-follow-my-blog-post-addon/7748623" class="button button"><?php esc_html_e( 'Purchase Extension', 'wpwfp' ); ?></a></span>
                </div>

                <div class="wpw-fp-available-extensions-inner-box wpw-fp-sms-notifications">
                    <img class="wpw-fp-extensions-thumbnail" alt="Extensions Image" src="<?php echo esc_url(WPW_FP_IMG_URL) . '/wpweb-schedule-sms-notifications.png'; ?>">
                    <h3><?php esc_html_e( 'Follow My Blog Post – SMS Notifications Extension', 'wpwfp' ); ?></h3>
                    <p><?php printf( esc_html__( 'With the %sSMS Notifications Extension%s for the Follow My Blog Post Plugin you can send sms notifications for updates to all your followers.', 'wpwfp' ), '<strong>','</strong>'); ?></p>
                    <span class="wpw-fp-action-links"><a target="_blank" href="https://codecanyon.net/item/sms-notifications-follow-my-blog-post-addon/20532462" class="button button"><?php esc_html_e( 'Purchase Extension', 'wpwfp' ); ?></a></span>
                </div>

                <?php
                    /**
                     * Fires follow my blog post extensions box after.
                     * 
                     * @package Follow My Blog Post
                     * @since 1.8.0
                     */
                    do_action( 'wpw_fp_extensions_box_after', '' );
                ?>

             </div><!--end of extensions main-->

        </div><!--.content wpw-fp-content-section-->

</div><!--end .wrap-->