(function (blocks, editor, components, i18n, element) {
  
  var el = element.createElement
  var registerBlockType = blocks.registerBlockType
  var BlockControls = editor.BlockControls
  var InspectorControls = editor.InspectorControls
  var TextControl = components.TextControl
  var SelectControl = components.SelectControl
  var CheckboxControl = components.CheckboxControl
  var ServerSideRender = components.ServerSideRender

  // custom block icon
  const iconEl = el('svg', { width: 20, height: 20 },
    el('path', { d: "M12.5,12H12v-0.5c0-0.3-0.2-0.5-0.5-0.5H11V6h1l1-2c-1,0.1-2,0.1-3,0C9.2,3.4,8.6,2.8,8,2V1.5C8,1.2,7.8,1,7.5,1 S7,1.2,7,1.5V2C6.4,2.8,5.8,3.4,5,4C4,4.1,3,4.1,2,4l1,2h1v5c0,0-0.5,0-0.5,0C3.2,11,3,11.2,3,11.5V12H2.5C2.2,12,2,12.2,2,12.5V13 h11v-0.5C13,12.2,12.8,12,12.5,12z M7,11H5V6h2V11z M10,11H8V6h2V11z" })
  );

  const { __ } = i18n;
  /* get all taxonomy */
  var taxonomies = [];
  taxonomies.push({ label: i18n.__('Select'), value: '' });
  for (var prop in fmbpbjs.wpw_fp_term_taxonomy) {

    for(var innerProp in fmbpbjs.wpw_fp_term_taxonomy[prop]){

      for(var doubleInnerProp in fmbpbjs.wpw_fp_term_taxonomy[prop][innerProp]){
        if(typeof fmbpbjs.wpw_fp_term_taxonomy[prop][innerProp][doubleInnerProp] == "object"){
          taxonomies.push({ label: prop+ ': ' +fmbpbjs.wpw_fp_term_taxonomy[prop][innerProp][doubleInnerProp].label, value: fmbpbjs.wpw_fp_term_taxonomy[prop][innerProp][doubleInnerProp].data_posttype+ '$$' +fmbpbjs.wpw_fp_term_taxonomy[prop][innerProp][doubleInnerProp].value });
        }
      }
    }
    
  }

  // register follow my blog posts custom block
  registerBlockType('wpweb/follow-my-blog-posts-block', {
    title: 'Follow My Blog Post',
    description: 'Add A Follow My Blog Post Shortcode as block using the Gutenberg editor.',
    icon: 'networking',
    category: 'widgets',
    attributes: { // Necessary for saving block content.
      wpw_fp_shortcodes: {
        type: 'string',
        default: ''
      },
      wpw_fp_post_id: {
        type: 'text',
        default: ''
      },
      wpw_fp_post_id_hidden: {
        type: 'hidden',
        default: fmbpbjs.wpw_fp_post_id
      },
      wpw_fp_disable_followers_count: {
        default: false
      },
      wpw_fp_followers_count_msg: {
        type: 'text',
        default: __('')
      },
      wpw_fp_follow_text: {
        type: 'text',
        default: __('')
      },
      wpw_fp_following_text: {
        type: 'text',
        default: __('')
      },
      wpw_fp_unfollow_text: {
        type: 'text',
        default: __('')
      },

      /* Author Follow button */
      wpw_fp_author_nm: {
        type: 'string',
        default: ''
      },
      wpw_fp_author_disable_followers_count: {
        default: false
      },
      wpw_fp_author_followers_count_msg: {
        type: 'text',
        default: __('')
      },
      wpw_fp_author_follow_text: {
        type: 'text',
        default: __('')
      },
      wpw_fp_author_following_text: {
        type: 'text',
        default: __('')
      },
      wpw_fp_author_unfollow_text: {
        type: 'text',
        default: __('')
      },

      /* Posts button */
      wpw_fp_only_following_post: {
        default: false
      },
      /* Terms button */
      wpw_fp_only_following_term: {
        default: false
      },
      /* Terms button */
      wpw_fp_only_following_author: {
        default: false
      },


      /* Term Follow button */
      wpw_fp_term_taxonomy_chosen: {
        type: 'string',
        default: __('Select')
      },
      wpw_fp_term_term_id_chosen: {
        type: 'text',
        default: __('')
      },
      wpw_fp_term_disable_followers_count: {
        default: false
      },
      wpw_fp_term_followers_count_msg: {
        type: 'text',
        default: __('')
      },
      wpw_fp_term_follow_text: {
        type: 'text',
        default: __('')
      },
      wpw_fp_term_following_text: {
        type: 'text',
        default: __('')
      },
      wpw_fp_term_unfollow_text: {
        type: 'text',
        default: __('')
      },


    },

    edit: function (props) {

      var attributes = props.attributes;
      var wpw_fp_shortcodes = props.attributes.wpw_fp_shortcodes;

      var wpw_fp_post_id = props.attributes.wpw_fp_post_id;
      var wpw_fp_post_id_hidden = props.attributes.wpw_fp_post_id_hidden;
      var wpw_fp_disable_followers_count = props.attributes.wpw_fp_disable_followers_count;
      var wpw_fp_followers_count_msg = props.attributes.wpw_fp_followers_count_msg;
      var wpw_fp_follow_text = props.attributes.wpw_fp_follow_text;
      var wpw_fp_following_text = props.attributes.wpw_fp_following_text;
      var wpw_fp_unfollow_text = props.attributes.wpw_fp_unfollow_text;

      var wpw_fp_followers_count_msg_class_name = "wpw_fp_followers_count_msg_class_name_show";
      if (wpw_fp_disable_followers_count) {
        wpw_fp_followers_count_msg_class_name = "wpw_fp_followers_count_msg_class_name_hide";
      }

      /* Author Follow button */
      var wpw_fp_author_nm = props.attributes.wpw_fp_author_nm;
      var wpw_fp_author_disable_followers_count = props.attributes.wpw_fp_author_disable_followers_count;
      var wpw_fp_author_followers_count_msg = props.attributes.wpw_fp_author_followers_count_msg;
      var wpw_fp_author_follow_text = props.attributes.wpw_fp_author_follow_text;
      var wpw_fp_author_following_text = props.attributes.wpw_fp_author_following_text;
      var wpw_fp_author_unfollow_text = props.attributes.wpw_fp_author_unfollow_text;

      var wpw_fp_author_followers_count_msg_class_name = "wpw_fp_author_followers_count_msg_class_name_show";
      if (wpw_fp_author_disable_followers_count) {
        wpw_fp_author_followers_count_msg_class_name = "wpw_fp_author_followers_count_msg_class_name_hide";
      }

      /* Term Follow button */
      var wpw_fp_term_taxonomy_chosen = props.attributes.wpw_fp_term_taxonomy_chosen;
      var wpw_fp_term_term_id_chosen = props.attributes.wpw_fp_term_term_id_chosen;
      var wpw_fp_term_disable_followers_count = props.attributes.wpw_fp_term_disable_followers_count;
      var wpw_fp_term_followers_count_msg = props.attributes.wpw_fp_term_followers_count_msg;
      var wpw_fp_term_follow_text = props.attributes.wpw_fp_term_follow_text;
      var wpw_fp_term_following_text = props.attributes.wpw_fp_term_following_text;
      var wpw_fp_term_unfollow_text = props.attributes.wpw_fp_term_unfollow_text;

      var wpw_fp_term_followers_count_msg_class_name = "wpw_fp_author_followers_count_msg_class_name_show";
      if (wpw_fp_term_disable_followers_count) {
        wpw_fp_term_followers_count_msg_class_name = "wpw_fp_author_followers_count_msg_class_name_hide";
      }

      /* Posts button */
      var wpw_fp_only_following_post = props.attributes.wpw_fp_only_following_post;
      
      /* Terms button */
      var wpw_fp_only_following_term = props.attributes.wpw_fp_only_following_term;
      
      /* Authors button */
      var wpw_fp_only_following_author = props.attributes.wpw_fp_only_following_author;

      if (wpw_fp_shortcodes.length == 0) {
        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                }
              }),

            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      } else if (wpw_fp_shortcodes == "wpw_follow_me") {
        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                }
              }),
              el(TextControl, {
                type: 'text',
                label: i18n.__('Post ID'),
                help: i18n.__('Enter a post / page id. Leave it empty to use the current post id.'),
                value: wpw_fp_post_id,
                onChange: function (response_wpw_fp_post_id) {
                  props.setAttributes({ wpw_fp_post_id: response_wpw_fp_post_id })
                }
              }),
              el(TextControl, {
                type: 'hidden',
                //label: i18n.__('Post ID Hidden'),
                value: wpw_fp_post_id_hidden,
                onChange: function (response_wpw_fp_post_id_hidden) {
                  props.setAttributes({ wpw_fp_post_id_hidden: response_wpw_fp_post_id_hidden })
                }
              }),
              // Disable Followers Count 
              el(CheckboxControl, {
                label: i18n.__('Disable Followers Count.'),
                help: i18n.__('Check this box if you want to hide followers count.'),
                checked: wpw_fp_disable_followers_count,
                onChange: function (response_wpw_fp_disable_followers_count) {
                  props.setAttributes({ wpw_fp_disable_followers_count: response_wpw_fp_disable_followers_count })
                }
              }),
              // Followers Counter Message
              el(TextControl, {
                type: 'text',
                className: wpw_fp_followers_count_msg_class_name,
                label: i18n.__('Followers Counter Message'),
                help: i18n.__('Here you can give the custom message to show followers count. Leave it empty to use the default one from the settings page. {followers_count} - displays the followers count.'),
                value: wpw_fp_followers_count_msg,
                onChange: function (response_wpw_fp_followers_count_msg) {
                  props.setAttributes({ wpw_fp_followers_count_msg: response_wpw_fp_followers_count_msg })
                }
              }),
              // Follow Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Follow Button Text'),
                help: i18n.__('Enter Follow button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_follow_text,
                onChange: function (response_wpw_fp_follow_text) {
                  props.setAttributes({ wpw_fp_follow_text: response_wpw_fp_follow_text })
                }
              }),
              // Following Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Following Button Text'),
                help: i18n.__('Enter Following button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_following_text,
                onChange: function (response_wpw_fp_following_text) {
                  props.setAttributes({ wpw_fp_following_text: response_wpw_fp_following_text })
                }
              }),
              // Unfollow Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Unfollow Button Text'),
                help: i18n.__('Enter Unfollow button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_unfollow_text,
                onChange: function (response_wpw_fp_unfollow_text) {
                  props.setAttributes({ wpw_fp_unfollow_text: response_wpw_fp_unfollow_text })
                }
              }),
            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      } else if (wpw_fp_shortcodes == "wpw_follow_author_me") {
        /* get all authors */
        var post_author = [];
        for (var prop in fmbpbjs.wpw_fp_author_nm) {
          post_author.push({ label: fmbpbjs.wpw_fp_author_nm[prop], value: prop });
        }
        
        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                },
                
              }),

              // Select Author
              el(SelectControl, {
                label: i18n.__('Select Author'),
                help: i18n.__(''),
                value: wpw_fp_author_nm,
                options: post_author,
                onChange: function (response_wpw_fp_author_nm) {
                  props.setAttributes({ wpw_fp_author_nm: response_wpw_fp_author_nm })
                }
              }),

              // Disable Followers Count 
              el(CheckboxControl, {
                label: i18n.__('Disable Followers Count'),
                help: i18n.__('Check this box if you want to hide followers count.'),
                checked: wpw_fp_author_disable_followers_count,
                onChange: function (response_wpw_fp_author_disable_followers_count) {
                  props.setAttributes({ wpw_fp_author_disable_followers_count: response_wpw_fp_author_disable_followers_count })
                }
              }),

              // Followers Counter Message
              el(TextControl, {
                type: 'text',
                className: wpw_fp_author_followers_count_msg_class_name,
                label: i18n.__('Followers Counter Message'),
                help: i18n.__('Here you can give the custom message to show followers count. Leave it empty to use the default one from the settings page. {followers_count} - displays the followers count.'),
                value: wpw_fp_author_followers_count_msg,
                onChange: function (response_wpw_fp_author_followers_count_msg) {
                  props.setAttributes({ wpw_fp_author_followers_count_msg: response_wpw_fp_author_followers_count_msg })
                }
              }),
              // Follow Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Follow Button Text'),
                help: i18n.__('Enter Follow button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_author_follow_text,
                onChange: function (response_wpw_fp_author_follow_text) {
                  props.setAttributes({ wpw_fp_author_follow_text: response_wpw_fp_author_follow_text })
                }
              }),
              // Following Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Following Button Text'),
                help: i18n.__('Enter Following button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_author_following_text,
                onChange: function (response_wpw_fp_author_following_text) {
                  props.setAttributes({ wpw_fp_author_following_text: response_wpw_fp_author_following_text })
                }
              }),
              // Unfollow Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Unfollow Button Text'),
                help: i18n.__('Enter Unfollow button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_author_unfollow_text,
                onChange: function (response_wpw_fp_author_unfollow_text) {
                  props.setAttributes({ wpw_fp_author_unfollow_text: response_wpw_fp_author_unfollow_text })
                }
              }),

            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      } else if (wpw_fp_shortcodes == "wpw_follow_post_list") {
        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                }
              }),

              // Only Following 
              el(CheckboxControl, {
                label: i18n.__('Only Following'),
                help: i18n.__('Check this box if you want to display only following posts.'),
                checked: wpw_fp_only_following_post,
                onChange: function (response_wpw_fp_only_following_post) {
                  props.setAttributes({ wpw_fp_only_following_post: response_wpw_fp_only_following_post })
                }
              }),
            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      } else if (wpw_fp_shortcodes == "wpw_follow_term_list") {
        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                }
              }),

              // Only Following 
              el(CheckboxControl, {
                label: i18n.__('Only Following'),
                help: i18n.__('Check this box if you want to display only following terms.'),
                checked: wpw_fp_only_following_term,
                onChange: function (response_wpw_fp_only_following_term) {
                  props.setAttributes({ wpw_fp_only_following_term: response_wpw_fp_only_following_term })
                }
              }),
            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      } else if (wpw_fp_shortcodes == "wpw_follow_author_list") {
        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                }
              }),

              // Only Following 
              el(CheckboxControl, {
                label: i18n.__('Only Following'),
                help: i18n.__('Check this box if you want to display only following authors.'),
                checked: wpw_fp_only_following_author,
                onChange: function (response_wpw_fp_only_following_author) {
                  props.setAttributes({ wpw_fp_only_following_author: response_wpw_fp_only_following_author })
                }
              }),
            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      }else if (wpw_fp_shortcodes == "wpw_follow_term_me") {

        return [
          el(BlockControls, { key: 'controls' }, // Display controls when the block is clicked on.
          ),
          el(InspectorControls, { key: 'inspector' }, // Display the block options in the inspector panel.
            el(components.PanelBody, {
              title: i18n.__('Follow My Blog Posts Settings'),
              className: 'wp-block-settings',
              initialOpen: true
            },
              // Select A Shortcode
              el(SelectControl, {
                label: i18n.__('Select A Shortcode'),
                help: i18n.__('Add A Follow My Blog Post Shortcode.'),
                value: wpw_fp_shortcodes,
                options: [
                  { label: i18n.__('Select'), value: '' },
                  { label: i18n.__('Post Follow Button'), value: 'wpw_follow_me' },
                  { label: i18n.__('Term Follow button'), value: 'wpw_follow_term_me' },
                  { label: i18n.__('Author Follow button'), value: 'wpw_follow_author_me' },
                  { label: i18n.__('Posts I Follow'), value: 'wpw_follow_post_list' },
                  { label: i18n.__('Terms I Follow'), value: 'wpw_follow_term_list' },
                  { label: i18n.__('Authors I Follow'), value: 'wpw_follow_author_list' },
                  
                ],
                onChange: function (response_wpw_fp_shortcodes) {
                  props.setAttributes({ wpw_fp_shortcodes: response_wpw_fp_shortcodes })
                }
              }),
              // Select Taxonomy
              el(SelectControl, {
                label: i18n.__('Select Taxonomy'),
                help: i18n.__('Select a taxonomy like category, tags.'),
                value: wpw_fp_term_taxonomy_chosen,
                options: taxonomies,
                onChange: function (response_wpw_fp_term_taxonomy_chosen) {
                  props.setAttributes({ wpw_fp_term_taxonomy_chosen: response_wpw_fp_term_taxonomy_chosen })
                }
              }),
              el(TextControl, {
                type: 'text',
                label: i18n.__('Term ID'),
                help: i18n.__('Enter a Term ID.'),
                value: wpw_fp_term_term_id_chosen,
                onChange: function (response_wpw_fp_term_term_id_chosen) {
                  props.setAttributes({ wpw_fp_term_term_id_chosen: response_wpw_fp_term_term_id_chosen })
                }
              }),
              // Disable Followers Count 
              el(CheckboxControl, {
                label: i18n.__('Disable Followers Count.'),
                help: i18n.__('Check this box if you want to hide followers count.'),
                checked: wpw_fp_term_disable_followers_count,
                onChange: function (response_wpw_fp_term_disable_followers_count) {
                  props.setAttributes({ wpw_fp_term_disable_followers_count: response_wpw_fp_term_disable_followers_count })
                }
              }),
              // Followers Counter Message
              el(TextControl, {
                type: 'text',
                className: wpw_fp_term_followers_count_msg_class_name,
                label: i18n.__('Followers Counter Message'),
                help: i18n.__('Here you can give the custom message to show followers count. Leave it empty to use the default one from the settings page. {followers_count} - displays the followers count.'),
                value: wpw_fp_term_followers_count_msg,
                onChange: function (response_wpw_fp_term_followers_count_msg) {
                  props.setAttributes({ wpw_fp_term_followers_count_msg: response_wpw_fp_term_followers_count_msg })
                }
              }),
              // Follow Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Follow Button Text'),
                help: i18n.__('Enter Follow button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_term_follow_text,
                onChange: function (response_wpw_fp_term_follow_text) {
                  props.setAttributes({ wpw_fp_term_follow_text: response_wpw_fp_term_follow_text })
                }
              }),
              // Following Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Following Button Text'),
                help: i18n.__('Enter Following button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_term_following_text,
                onChange: function (response_wpw_fp_term_following_text) {
                  props.setAttributes({ wpw_fp_term_following_text: response_wpw_fp_term_following_text })
                }
              }),
              // Unfollow Button Text
              el(TextControl, {
                type: 'text',
                label: i18n.__('Unfollow Button Text'),
                help: i18n.__('Enter Unfollow button text. Leave it empty to use the default one from the settings page.'),
                value: wpw_fp_term_unfollow_text,
                onChange: function (response_wpw_fp_term_unfollow_text) {
                  props.setAttributes({ wpw_fp_term_unfollow_text: response_wpw_fp_term_unfollow_text })
                }
              }),
            )
          ),
          el(ServerSideRender, {
            block: 'wpweb/follow-my-blog-posts-block',
            attributes: attributes,
          }),
        ]
      }
    },

    save: function (props) {
      return null;
    },
  });
}(
  window.wp.blocks,
  window.wp.editor,
  window.wp.components,
  window.wp.i18n,
  window.wp.element
));
