"use strict";

jQuery(document).ready(function($) {
	
	// Code used for follow post popup
	$( document ).on( "click", ".wpw-fp-follow-post-wrapper .wpw-fp-guest-btn", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-follow-post-wrapper' );
		
		// trigger follow guest button click
		var follow_wrapper_obj = { this_object : follow_wrapper };			
		follow_wrapper.trigger( "wpw-fp-guest-btn-click", [follow_wrapper_obj] );
		
		follow_wrapper.find( '.wpw-fp-followsemail' ).val( '' ).removeClass( 'wpw_fp_email_error' );
		follow_wrapper.find( '.wpw_fp_follow_email_error' ).hide();
		
		follow_wrapper.find( '.wpw-fp-follow-post-popup' ).slideDown( 'slow' );
		follow_wrapper.find( '.wpw-fp-post-popup-overlay' ).fadeIn( 'slow' );
	});
	
	// Code used for follow post
	$( document ).on( "click", ".wpw-fp-follow-post-wrapper .wpw-fp-follow-btn", function() {
		
		var onlyfollowing 	= $(this).parents('.wpw-fp-manage-follow-posts').data('only-following');
		var status 			= $(this).attr('data-status');
		var postid 			= $(this).attr('data-postid');
		var currentpostid 	= $(this).attr('data-current-postid');
		var follow		 	= $(this).attr('data-follow-text');
		var following		= $(this).attr('data-following-text');
		var unfollow		= $(this).attr('data-unfollow-text');
		var email	= '';
		
		// trigger follow button click event
		var follow_button_obj = { popup : true, error : false, this_object : this };
		$( this ).trigger( "wpw-fp-follow-btn-click", [follow_button_obj] );
				
		var follow_wrapper = $( this ).parents( '.wpw-fp-follow-post-wrapper' );
		
		if( follow_wrapper.find( '.wpw-fp-followsemail' ).is( ':visible' ) ) {
			
			follow_wrapper.find( '.wpw_fp_follow_email_error' ).html('').hide();
			follow_wrapper.find( '.wpw-fp-followsemail' ).removeClass('wpw_fp_email_error');
			
			email 	= follow_wrapper.find( '.wpw-fp-followsemail' ).val();
			email 	= $.trim( email );
			
			if( email == '' ) { // Check email is empty
				follow_wrapper.find( '.wpw_fp_follow_email_error' ).html( WpwFpPublic.emailempty ).show();
				follow_wrapper.find( '.wpw-fp-followsemail' ).addClass( 'wpw_fp_email_error' );
				return false;
			} else {
				if( !wpw_fp_valid_email( email ) ) { // Check email is valid or not
					follow_wrapper.find( '.wpw_fp_follow_email_error' ).html( WpwFpPublic.emailinvalid ).show();
					follow_wrapper.find( '.wpw-fp-followsemail' ).addClass( 'wpw_fp_email_error' );
					return false;
				}
			}
		}
		
		if( !follow_button_obj.popup ) {
			return false;
		}
		
		if( follow_button_obj.error ) {
			return false;
		}
		
		if( status == '1' ) {
			follow_wrapper.find( '.wpw-following-text' ).html( following );
			follow_wrapper.find( '.wpw-following-text' ).removeClass( 'wpw-fp-display-none' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
		} else {
			follow_wrapper.find( '.wpw-fp-follow-btn' ).addClass( 'wpw-fp-follow-button' ).removeClass( 'wpw-fp-following-button' );
			follow_wrapper.find( '.wpw-following-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).removeClass( 'wpw-fp-display-none' ).addClass( 'wpw-fp-display-inline' );
		}
		
		var form = follow_wrapper.find(".wpw_fp_follow_form");
		var disable_reload = ( follow_wrapper.find( '.wpw-fp-guest-btn' ).hasClass('disable-reload') || follow_wrapper.parents('.widget').length > 0 );
		
		var data = { 
						action			:	'wpw_fp_follow_post',
						status			:	status,
						postid			:	postid,
						currentpostid	:	currentpostid,
						email			:	email,
						onlyfollowing	:	onlyfollowing,
						data			: 	form.serialize()
					};

		//Check if need disable reload and message on same page
		if( disable_reload ) {
			data.disable_reload = true;
		}

		//show loader
		follow_wrapper.find( '.wpw_fp_follow_loader' ).show();
		follow_wrapper.find( '.wpw-following-text' ).html( WpwFpPublic.processing );
		follow_wrapper.find( '.wpw-unfollowing-text' ).html( WpwFpPublic.processing );
		
		jQuery.post( WpwFpPublic.ajaxurl,data,function(response) {
		
			//hide loader
			follow_wrapper.find( '.wpw_fp_follow_loader' ).hide();
			
			if( response != 'confirm' ) {
				
				//Check if numeric value
				if( $.isNumeric(response) ) {
					follow_wrapper.find( '.wpw_fp_followers_count' ).html( response );
				}
				
				if( WpwFpPublic.loginflag == '1' ) {

					if( status == '1' ) {
						follow_wrapper.find( '.wpw-following-text' ).html( following );
						follow_wrapper.find( '.wpw-fp-follow-btn' ).attr( 'data-status', '0' );
						follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-follow-button' ).addClass( 'wpw-fp-following-button' );
					} else {
						if(onlyfollowing == 1)
						{
							var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-posts').html();
							jQuery('.wpw-fp-manage-follow-posts').html(newresponse);
						}
						else
						{
							follow_wrapper.find( '.wpw-following-text' ).html( follow );
							follow_wrapper.find( '.wpw-fp-follow-btn' ).attr( 'data-status', '1' );
							follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-following-button' ).addClass( 'wpw-fp-follow-button' );
						}
					}

				} else {
					//make text of following and unfollowing to as it is "Follow" & "Unfollow"
					follow_wrapper.find( '.wpw-following-text' ).html( follow );
					follow_wrapper.find( '.wpw-unfollowing-text' ).html( unfollow );
					//make follow button text as it is "Follow"
					follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-following-button' ).addClass( 'wpw-fp-follow-button' );

					if( disable_reload ) {

						if( ! $.isNumeric(response) ) {

							//show confirm email message to user
							$( '.message_stack_success, .message_stack_error' ).remove();
							$( '<div class="message_stack_error">' + response + '<div>' ).insertBefore( follow_wrapper );

						} else {

							//show confirm email message to user
							$( '.message_stack_success, .message_stack_error' ).remove();
							$( '<div class="message_stack_success">' + WpwFpPublic.follow_success + '<div>' ).insertBefore( follow_wrapper );
						}

						//Hide popup if exists
						if( follow_wrapper.find( '.wpw-fp-popup-close' ).length > 0 ) { follow_wrapper.find( '.wpw-fp-popup-close' ).click(); }

					} else {
						window.location.reload();
					}
				}
				
			} else { 

				if( WpwFpPublic.loginflag == '1' || disable_reload ) {
					//show confirm email message to user
					$( '.message_stack_success' ).remove();
					$( '<div class="message_stack_success">' + WpwFpPublic.checkemail + '<div>' ).insertBefore( follow_wrapper );
					//make button text to follow
					follow_wrapper.find( '.wpw-following-text' ).html( follow );

					//Hide popup if exists
					if( follow_wrapper.find( '.wpw-fp-popup-close' ).length > 0 ) { follow_wrapper.find( '.wpw-fp-popup-close' ).click(); }

				} else {
					
					follow_wrapper.find( '.wpw-following-text' ).html( follow );
					window.location.reload();
				}
			}
			
			// trigger follow button reload event to reload page from 3rd party plugin
			var follow_wrapper_obj = { this_object : follow_wrapper };			
			follow_wrapper.trigger( "wpw-fp-follow-btn-reload", [follow_wrapper_obj] );
			
			follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-unfollow-button' ).addClass( 'wpw-fp-follow-button' );
			follow_wrapper.find( '.wpw-following-text' ).removeClass( 'wpw-fp-display-none' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
			//make unfollow button text as it is
			follow_wrapper.find( '.wpw-unfollowing-text' ).html( unfollow );
		});
		
	});
	
	// Code used for follow term popup
	$( document ).on( "click", ".wpw-fp-follow-term-wrapper .wpw-fp-guest-btn", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-follow-term-wrapper' );
		
		// trigger follow guest button click
		var follow_wrapper_obj = { this_object : follow_wrapper };			
		follow_wrapper.trigger( "wpw-fp-term-guest-btn-click", [follow_wrapper_obj] );
		
		follow_wrapper.find( '.wpw-fp-followsemail' ).val( '' ).removeClass( 'wpw_fp_email_error' );
		follow_wrapper.find( '.wpw_fp_follow_email_error' ).hide();
		
		follow_wrapper.find( '.wpw-fp-follow-term-popup' ).slideDown( 'slow' );
		follow_wrapper.find( '.wpw-fp-term-popup-overlay' ).fadeIn( 'slow' );
	});
	
	// Code used for follow author popup
	$( document ).on( "click", ".wpw-fp-follow-author-wrapper .wpw-fp-guest-btn", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-follow-author-wrapper' );
		
		// trigger follow guest button click
		var follow_wrapper_obj = { this_object : follow_wrapper };			
		follow_wrapper.trigger( "wpw-fp-author-guest-btn-click", [follow_wrapper_obj] );
		
		follow_wrapper.find( '.wpw-fp-followsemail' ).val( '' ).removeClass( 'wpw_fp_email_error' );
		follow_wrapper.find( '.wpw_fp_follow_email_error' ).hide();
		
		follow_wrapper.find( '.wpw-fp-follow-author-popup' ).slideDown( 'slow' );
		follow_wrapper.find( '.wpw-fp-author-popup-overlay' ).fadeIn( 'slow' );
	});
	
	// Code start for follow term
	$( document ).on( "click", ".wpw-fp-follow-term-wrapper .wpw-fp-follow-btn", function() {
		
		var onlyfollowing 	= $(this).parents('.wpw-fp-manage-follow-terms').data('only-following');
		var status 			= $(this).attr('data-status');
		var posttype 		= $(this).attr('data-posttype');
		var taxonomyslug 	= $(this).attr('data-taxonomy-slug');
		var termid 			= $(this).attr('data-term-id');
		var currentpostid 	= $(this).attr('data-current-postid');
		var follow		 	= $(this).attr('data-follow-text');
		var following		= $(this).attr('data-following-text');
		var unfollow		= $(this).attr('data-unfollow-text');
		var email	= '';
		
		// trigger follow button click event
		var follow_button_obj = { popup : true, error : false, this_object : this };
		$( this ).trigger( "wpw-fp-follow-term-btn-click", [follow_button_obj] );
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-follow-term-wrapper' );
		
		if( follow_wrapper.find( '.wpw-fp-followsemail' ).is(':visible') ) {
			
			follow_wrapper.find( '.wpw_fp_follow_email_error' ).html('').hide();
			follow_wrapper.find( '.wpw-fp-followsemail' ).removeClass( 'wpw_fp_email_error' );
			
			email 	= follow_wrapper.find( '.wpw-fp-followsemail' ).val();
			email 	= $.trim( email );
			
			if( email == '' ) { // Check email is empty
				follow_wrapper.find( '.wpw_fp_follow_email_error' ).html( WpwFpPublic.emailempty ).show();
				follow_wrapper.find( '.wpw-fp-followsemail' ).addClass( 'wpw_fp_email_error' );
				return false;
			} else {
				if( !wpw_fp_valid_email( email ) ) { // Check email is valid or not
					follow_wrapper.find( '.wpw_fp_follow_email_error' ).html( WpwFpPublic.emailinvalid ).show();
					follow_wrapper.find( '.wpw-fp-followsemail' ).addClass( 'wpw_fp_email_error' );
					return false;
				}
			}
		}
		
		if( !follow_button_obj.popup ) {
			return false;
		}
		
		if( follow_button_obj.error ) {
			return false;
		}
		
		if( status == '1' ) {
			follow_wrapper.find( '.wpw-following-text' ).html( following );
			follow_wrapper.find( '.wpw-following-text' ).removeClass( 'wpw-fp-display-none' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
		} else {
			follow_wrapper.find( '.wpw-fp-follow-btn' ).addClass( 'wpw-fp-follow-button' ).removeClass( 'wpw-fp-following-button' );
			follow_wrapper.find( '.wpw-following-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).removeClass( 'wpw-fp-display-none' ).addClass( 'wpw-fp-display-inline' );
		}
		
		var form = follow_wrapper.find(".wpw_fp_follow_form");
		var disable_reload = ( follow_wrapper.find( '.wpw-fp-guest-btn' ).hasClass('disable-reload') || follow_wrapper.parents('.widget').length > 0 );
		
		var data = { 
						action			:	'wpw_fp_follow_term',
						status			:	status,
						posttype		:	posttype,
						taxonomyslug	:	taxonomyslug,
						termid			:	termid,
						currentpostid	:	currentpostid,
						email			:	email,
						onlyfollowing	:	onlyfollowing,
						data			: 	form.serialize()
					};

		//Check if need disable reload and message on same page
		if( disable_reload ) {
			data.disable_reload = true;
		}

		//show loader
		follow_wrapper.find( '.wpw_fp_follow_loader' ).show();
		follow_wrapper.find( '.wpw-following-text' ).html( WpwFpPublic.processing );
		follow_wrapper.find( '.wpw-unfollowing-text' ).html( WpwFpPublic.processing );
		
		jQuery.post( WpwFpPublic.ajaxurl,data,function(response) {
		
			//hide loader
			follow_wrapper.find( '.wpw_fp_follow_loader' ).hide();
			
			if( response != 'confirm' ) {
				
				//Check if numeric value
				if( $.isNumeric(response) ) {
					follow_wrapper.find( '.wpw_fp_followers_count' ).html( response );
				}
				
				if( WpwFpPublic.loginflag == '1' ) {
					
					if( status == '1' ) {
						follow_wrapper.find( '.wpw-following-text' ).html( following );
						follow_wrapper.find( '.wpw-fp-follow-btn' ).attr( 'data-status', '0' );
						follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-follow-button' ).addClass( 'wpw-fp-following-button' );
					} else {
						
						if(onlyfollowing == 1)
						{
							var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-terms').html();
							jQuery('.wpw-fp-manage-follow-terms').html(newresponse);
						}
						else
						{
							follow_wrapper.find( '.wpw-following-text' ).html( follow );
							follow_wrapper.find( '.wpw-fp-follow-btn' ).attr( 'data-status', '1' );
							follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-following-button' ).addClass( 'wpw-fp-follow-button' );
						}
					}
				} else {
					//make text of following and unfollowing to as it is "Follow" & "Unfollow"
					follow_wrapper.find( '.wpw-following-text' ).html( follow );
					follow_wrapper.find( '.wpw-unfollowing-text' ).html( unfollow );
					//make follow button text as it is "Follow"
					follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-following-button' ).addClass( 'wpw-fp-follow-button' );

					if( disable_reload ) {

						if( ! $.isNumeric(response) ) {

							//show confirm email message to user
							$( '.message_stack_success, .message_stack_error' ).remove();
							$( '<div class="message_stack_error">' + response + '<div>' ).insertBefore( follow_wrapper );

						} else {

							//show confirm email message to user
							$( '.message_stack_success, .message_stack_error' ).remove();
							$( '<div class="message_stack_success">' + WpwFpPublic.follow_success + '<div>' ).insertBefore( follow_wrapper );
						}

						//Hide popup if exists
						if( follow_wrapper.find( '.wpw-fp-popup-close' ).length > 0 ) { follow_wrapper.find( '.wpw-fp-popup-close' ).click(); }

					} else {
						window.location.reload();
					}
				}
				
			} else { 
				
				if( WpwFpPublic.loginflag == '1' || disable_reload ) {
					//show confirm email message to user
					$( '.message_stack_success' ).remove();
					$( '<div class="message_stack_success">' + WpwFpPublic.checkemail + '<div>' ).insertBefore( follow_wrapper );									
					//make button text to follow
					follow_wrapper.find( '.wpw-following-text' ).html( follow );

					//Hide popup if exists
					if( follow_wrapper.find( '.wpw-fp-popup-close' ).length > 0 ) { follow_wrapper.find( '.wpw-fp-popup-close' ).click(); }

				} else {
					
					follow_wrapper.find( '.wpw-following-text' ).html( follow );
					window.location.reload();
				}
			}
			
			// trigger follow button reload event to reload page from 3rd party plugin
			var follow_wrapper_obj = { this_object : follow_wrapper };			
			follow_wrapper.trigger( "wpw-fp-follow-term-btn-reload", [follow_wrapper_obj] );
			
			follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-unfollow-button' ).addClass( 'wpw-fp-follow-button' );
			follow_wrapper.find( '.wpw-following-text' ).removeClass( 'wpw-fp-display-none' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
			//make unfollow button text as it is
			follow_wrapper.find( '.wpw-unfollowing-text' ).html( unfollow );
		});
		
	});
	
	// Code start for follow Author
	$( document ).on( 'click', '.wpw-fp-follow-author-wrapper .wpw-fp-follow-btn', function() {
		
		var onlyfollowing 	= $(this).parents('.wpw-fp-manage-follow-authors').data('only-following');
		var status 			= $(this).attr('data-status');
		var authorid 		= $(this).attr('data-author-id');
		var currentpostid 	= $(this).attr('data-current-postid');
		var follow		 	= $(this).attr('data-follow-text');
		var following		= $(this).attr('data-following-text');
		var unfollow		= $(this).attr('data-unfollow-text');
		var email	= '';

		// trigger follow button click event
		var follow_button_obj = { popup : true, error : false, this_object : this };
		$( this ).trigger( "wpw-fp-follow-author-btn-click", [follow_button_obj] );
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-follow-author-wrapper' );
		email 	= follow_wrapper.find( '.wpw-fp-followsemail' ).val();

		if( follow_wrapper.find( '.wpw-fp-followsemail' ).is(':visible') ) {
			
			follow_wrapper.find( '.wpw_fp_follow_email_error' ).html('').hide();
			follow_wrapper.find( '.wpw-fp-followsemail' ).removeClass( 'wpw_fp_email_error' );
			
			email 	= follow_wrapper.find( '.wpw-fp-followsemail' ).val();
			email 	= $.trim( email );
			
			if( email == '' ) { // Check email is empty
				follow_wrapper.find( '.wpw_fp_follow_email_error' ).html( WpwFpPublic.emailempty ).show();
				follow_wrapper.find( '.wpw-fp-followsemail' ).addClass( 'wpw_fp_email_error' );
				return false;
			} else {
				if( !wpw_fp_valid_email( email ) ) { // Check email is valid or not
					follow_wrapper.find( '.wpw_fp_follow_email_error' ).html( WpwFpPublic.emailinvalid ).show();
					follow_wrapper.find( '.wpw-fp-followsemail' ).addClass( 'wpw_fp_email_error' );
					return false;
				}
			}
		}
		
		if( !follow_button_obj.popup ) {
			return false;
		}
		
		if( follow_button_obj.error ) {
			return false;
		}
		
		if( status == '1' ) {
			follow_wrapper.find( '.wpw-following-text' ).html( following );
			follow_wrapper.find( '.wpw-following-text' ).removeClass( 'wpw-fp-display-none' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
		} else {
			follow_wrapper.find( '.wpw-fp-follow-btn' ).addClass( 'wpw-fp-follow-button' ).removeClass( 'wpw-fp-following-button' );
			follow_wrapper.find( '.wpw-following-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).removeClass( 'wpw-fp-display-none' ).addClass( 'wpw-fp-display-inline' );
		}
		
		var form = follow_wrapper.find(".wpw_fp_follow_form");
		var disable_reload = ( follow_wrapper.find( '.wpw-fp-guest-btn' ).hasClass('disable-reload') || follow_wrapper.parents('.widget').length > 0 );

		var data = { 
						action			:	'wpw_fp_follow_author',
						status			:	status,
						authorid		:	authorid,
						currentpostid	:	currentpostid,
						email			:	email,
						onlyfollowing	:	onlyfollowing,
						data			: 	form.serialize()
					};

		//Check if need disable reload and message on same page
		if( disable_reload ) {
			data.disable_reload = true;
		}

		//show loader
		follow_wrapper.find( '.wpw_fp_follow_loader' ).show();
		follow_wrapper.find( '.wpw-following-text' ).html( WpwFpPublic.processing );
		follow_wrapper.find( '.wpw-unfollowing-text' ).html( WpwFpPublic.processing );
		
		jQuery.post( WpwFpPublic.ajaxurl,data,function(response) {
		
			//hide loader
			follow_wrapper.find( '.wpw_fp_follow_loader' ).hide();
			
			if( response != 'confirm' ) {
				
				//Check if numeric value
				if( $.isNumeric(response) ) {
					follow_wrapper.find( '.wpw_fp_followers_count' ).html( response );
				}
				
				if( WpwFpPublic.loginflag == '1' ) {
					
					if( status == '1' ) {
						follow_wrapper.find( '.wpw-following-text' ).html( following );
						follow_wrapper.find( '.wpw-fp-follow-btn' ).attr( 'data-status', '0' );
						follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-follow-button' ).addClass( 'wpw-fp-following-button' );
					} else {
						
						if(onlyfollowing == 1)
						{
							var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-authors').html();
							jQuery('.wpw-fp-manage-follow-authors').html(newresponse);
						}
						else
						{
							follow_wrapper.find( '.wpw-following-text' ).html( follow );
							follow_wrapper.find( '.wpw-fp-follow-btn' ).attr( 'data-status', '1' );
							follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-following-button' ).addClass( 'wpw-fp-follow-button' );
						}
					}
				} else {
					//make text of following and unfollowing to as it is "Follow" & "Unfollow"
					follow_wrapper.find( '.wpw-following-text' ).html( follow );
					follow_wrapper.find( '.wpw-unfollowing-text' ).html( unfollow );
					//make follow button text as it is "Follow"
					follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-following-button' ).addClass( 'wpw-fp-follow-button' );

					if( disable_reload ) {

						if( ! $.isNumeric(response) ) {

							//show confirm email message to user
							$( '.message_stack_success, .message_stack_error' ).remove();
							$( '<div class="message_stack_error">' + response + '<div>' ).insertBefore( follow_wrapper );

						} else {

							//show confirm email message to user
							$( '.message_stack_success, .message_stack_error' ).remove();
							$( '<div class="message_stack_success">' + WpwFpPublic.follow_success + '<div>' ).insertBefore( follow_wrapper );
						}

						//Hide popup if exists
						if( follow_wrapper.find( '.wpw-fp-popup-close' ).length > 0 ) { follow_wrapper.find( '.wpw-fp-popup-close' ).click(); }

					} else {
						window.location.reload();
					}
				}
				
			} else { 
				
				if( WpwFpPublic.loginflag == '1' || disable_reload ) {
					//show confirm email message to user
					$( '.message_stack_success' ).remove();
					$( '<div class="message_stack_success">' + WpwFpPublic.checkemail + '<div>' ).insertBefore( follow_wrapper );
					//make button text to follow
					follow_wrapper.find( '.wpw-following-text' ).html( follow );

					//Hide popup if exists
					if( follow_wrapper.find( '.wpw-fp-popup-close' ).length > 0 ) { follow_wrapper.find( '.wpw-fp-popup-close' ).click(); }

				} else {
					
					follow_wrapper.find( '.wpw-following-text' ).html( follow );
					window.location.reload();
				}
			}
			
			// trigger follow button reload event to reload page from 3rd party plugin
			var follow_wrapper_obj = { this_object : follow_wrapper };			
			follow_wrapper.trigger( "wpw-fp-follow-author-btn-reload", [follow_wrapper_obj] );
			
			follow_wrapper.find( '.wpw-fp-follow-btn' ).removeClass( 'wpw-fp-unfollow-button' ).addClass( 'wpw-fp-follow-button' );
			follow_wrapper.find( '.wpw-following-text' ).removeClass( 'wpw-fp-display-none' );
			follow_wrapper.find( '.wpw-unfollowing-text' ).addClass( 'wpw-fp-display-none' ).removeClass( 'wpw-fp-display-inline' );
			//make unfollow button text as it is
			follow_wrapper.find( '.wpw-unfollowing-text' ).html( unfollow );
		});
		
	});
	
	$( document ).on( "click", ".wpw-fp-popup-close, .wpw-fp-popup-overlay", function() {
		$('.wpw-fp-follow-popup').slideUp('slow');
		$('.wpw-fp-popup-overlay').fadeOut('slow');
	});
	
	$( document ).on( "click", "#wpw_fp_unsubscribe_submit", function() {
		
		$( '.wpw-fp-unsubscribe-email-error' ).removeClass( 'message_stack_error' ).html('').hide();
		$( '#wpw_fp_unsubscribe_email' ).removeClass( 'wpw_fp_email_error' );
		$( '.message_stack_success' ).hide();
		$( '.message_stack_error' ).hide();
		
		var email = $.trim( $( '#wpw_fp_unsubscribe_email' ).val() );
		
		if( email == '' ) { // Check email is empty
			$( '.wpw-fp-unsubscribe-email-error' ).addClass( 'message_stack_error' ).html( WpwFpPublic.emailempty ).show();
			$( '#wpw_fp_unsubscribe_email' ).addClass( 'wpw_fp_email_error' ).show();
			return false;
		} else {
			if( !wpw_fp_valid_email( email ) ) { // Check email is valid or not
				$( '.wpw-fp-unsubscribe-email-error' ).addClass( 'message_stack_error' ).html( WpwFpPublic.emailinvalid ).show();
				$( '#wpw_fp_unsubscribe_email' ).addClass( 'wpw_fp_email_error' ).show();
				return false;
			}
		}
	});
	
	$( document ).on( "click", ".wpw-fb-cb-posts", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-posts' );
		
		if( $( this ).is( ':checked' ) ) {
			
			follow_wrapper.find( '.wpw-fp-cb-post' ).each( function() {
				follow_wrapper.find( this ).attr( 'checked', true );
			});
			follow_wrapper.find( '.wpw-fp-cb-posts-1' ).attr( 'checked', true );
			follow_wrapper.find( '.wpw-fp-cb-posts-2' ).attr( 'checked', true );
		} else {
			
			follow_wrapper.find( '.wpw-fp-cb-post' ).each( function() {
				follow_wrapper.find( this ).attr( 'checked', false );
			});
			follow_wrapper.find( '.wpw-fp-cb-posts-1' ).attr( 'checked', false );
			follow_wrapper.find( '.wpw-fp-cb-posts-2' ).attr( 'checked', false );
		}
	});
	
	$( document ).on( "click", ".wpw-fp-cb-post", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-posts' );
		if( !( $( this ).is( ':checked' ) ) ) {
			follow_wrapper.find( '.wpw-fp-cb-posts-1' ).attr( 'checked', false );
			follow_wrapper.find( '.wpw-fp-cb-posts-2' ).attr( 'checked', false );
		}
	});
	
	$( document ).on( "click", ".wpw-fp-bulk-action-post-btn", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-posts' );
		var bulkaction = follow_wrapper.find( '.wpw-fp-bulk-action' ).val();
		var pid = follow_wrapper.find( '.wpw-fp-bulk-paging' ).val();
		var ids = ',';
		
		follow_wrapper.find( '.wpw-fp-cb-post' ).each( function() {
			if( $( this ).is( ':checked' ) ) {
				ids += $( this ).val() + ',';
			}
		});
		 
		if( bulkaction != '' && ids != ',' ) {
			var data = {
							action: 'wpw_fp_bulk_action_post',
							bulkaction: bulkaction,
							ids: ids,
							paging: pid
						};
			
			follow_wrapper.find('.wpw-fp-bulk-action-loader').show();
			
			jQuery.post( WpwFpPublic.ajaxurl, data, function(response) {
				var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-posts').html();
				follow_wrapper.find('.wpw-fp-bulk-action-loader').hide();
				jQuery('.wpw-fp-manage-follow-posts').html(newresponse);
			});
		}
		return false;
	});
	
	$( document ).on( "click", ".wpw-fb-cb-terms", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-terms' );
		
		if( $( this ).is( ':checked' ) ) {
			
			follow_wrapper.find( '.wpw-fp-cb-term' ).each( function() {
				follow_wrapper.find( this ).attr( 'checked', true );
			});
			follow_wrapper.find( '.wpw-fp-cb-terms-1' ).attr( 'checked', true );
			follow_wrapper.find( '.wpw-fp-cb-terms-2' ).attr( 'checked', true );
		} else {
			
			follow_wrapper.find( '.wpw-fp-cb-term' ).each( function() {
				follow_wrapper.find( this ).attr( 'checked', false );
			});
			follow_wrapper.find( '.wpw-fp-cb-terms-1' ).attr( 'checked', false );
			follow_wrapper.find( '.wpw-fp-cb-terms-2' ).attr( 'checked', false );
		}
	});
	
	$( document ).on( "click", ".wpw-fp-cb-term", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-terms' );
		if( !( $( this ).is( ':checked' ) ) ) {
			follow_wrapper.find( '.wpw-fp-cb-terms-1' ).attr( 'checked', false );
			follow_wrapper.find( '.wpw-fp-cb-terms-2' ).attr( 'checked', false );
		}
	});
	
	$( document ).on( "click", ".wpw-fp-bulk-action-term-btn", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-terms' );
		var bulkaction = follow_wrapper.find( '.wpw-fp-bulk-action' ).val();
		var pid = follow_wrapper.find( '.wpw-fp-bulk-paging' ).val();
		var ids = ',';
		
		follow_wrapper.find( '.wpw-fp-cb-term' ).each( function() {
			if( $( this ).is( ':checked' ) ) {
				ids += $( this ).val() + ',';
			}
		});
		 
		if( bulkaction != '' && ids != ',' ) {
			var data = {
							action: 'wpw_fp_bulk_action_term',
							bulkaction: bulkaction,
							ids: ids,
							paging: pid
						};
			
			follow_wrapper.find('.wpw-fp-bulk-action-loader').show();
			
			jQuery.post( WpwFpPublic.ajaxurl, data, function(response) {
				var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-terms').html();
				follow_wrapper.find('.wpw-fp-bulk-action-loader').hide();
				jQuery('.wpw-fp-manage-follow-terms').html(newresponse);
			});
		}
		return false;
	});
	
	$( document ).on( "click", ".wpw-fb-cb-authors", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-authors' );
		
		if( $( this ).is( ':checked' ) ) {
			
			follow_wrapper.find( '.wpw-fp-cb-author' ).each( function() {
				follow_wrapper.find( this ).attr( 'checked', true );
			});
			follow_wrapper.find( '.wpw-fp-cb-authors-1' ).attr( 'checked', true );
			follow_wrapper.find( '.wpw-fp-cb-authors-2' ).attr( 'checked', true );
		} else {
			
			follow_wrapper.find( '.wpw-fp-cb-author' ).each( function() {
				follow_wrapper.find( this ).attr( 'checked', false );
			});
			follow_wrapper.find( '.wpw-fp-cb-authors-1' ).attr( 'checked', false );
			follow_wrapper.find( '.wpw-fp-cb-authors-2' ).attr( 'checked', false );
		}
	});
	
	$( document ).on( "click", ".wpw-fp-cb-author", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-authors' );
		if( !( $( this ).is( ':checked' ) ) ) {
			follow_wrapper.find( '.wpw-fp-cb-authors-1' ).attr( 'checked', false );
			follow_wrapper.find( '.wpw-fp-cb-authors-2' ).attr( 'checked', false );
		}
	});
	
	$( document ).on( "click", ".wpw-fp-bulk-action-author-btn", function() {
		
		var follow_wrapper = $( this ).parents( '.wpw-fp-manage-follow-authors' );
		var bulkaction = follow_wrapper.find( '.wpw-fp-bulk-action' ).val();
		var pid = follow_wrapper.find( '.wpw-fp-bulk-paging' ).val();
		var ids = ',';
		
		follow_wrapper.find( '.wpw-fp-cb-author' ).each( function() {
			if( $( this ).is( ':checked' ) ) {
				ids += $( this ).val() + ',';
			}
		});
		 
		if( bulkaction != '' && ids != ',' ) {
			var data = {
							action: 'wpw_fp_bulk_action_author',
							bulkaction: bulkaction,
							ids: ids,
							paging: pid
						};
			
			follow_wrapper.find('.wpw-fp-bulk-action-loader').show();
			
			jQuery.post( WpwFpPublic.ajaxurl, data, function(response) {
				var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-authors').html();
				follow_wrapper.find('.wpw-fp-bulk-action-loader').hide();
				jQuery('.wpw-fp-manage-follow-authors').html(newresponse);
			});
		}
		return false;
	});
});

//function for follow post ajax pagination
function wpw_fp_follow_post_ajax_pagination(pid){
	
	var data = {
					action: 'wpw_fp_follow_post_next_page',
					paging: pid
				};
		
	jQuery('.wpw-fp-follow-posts-loader').show();
	jQuery('.wpw-fp-follow-posts-paging').hide();
	
	jQuery.post( WpwFpPublic.ajaxurl, data, function(response) {
		var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-posts').html();
		jQuery('.wpw-fp-follow-posts-loader').hide();
		jQuery('.wpw-fp-manage-follow-posts').html(newresponse);
	});	
	return false;
}

//function for follow author ajax pagination
function wpw_fp_follow_author_ajax_pagination(pid){
	
	var data = {
					action: 'wpw_fp_follow_author_next_page',
					paging: pid
				};
		
	jQuery('.wpw-fp-follow-authors-loader').show();
	jQuery('.wpw-fp-follow-authors-paging').hide();
	
	jQuery.post( WpwFpPublic.ajaxurl, data, function(response) {
		var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-authors').html();
		jQuery('.wpw-fp-follow-authors-loader').hide();
		jQuery('.wpw-fp-manage-follow-authors').html(newresponse);
	});	
	return false;
}
//function for follow term ajax pagination
function wpw_fp_follow_term_ajax_pagination(pid){
	
	var data = {
					action: 'wpw_fp_follow_term_next_page',
					paging: pid
				};
		
	jQuery('.wpw-fp-follow-terms-loader').show();
	jQuery('.wpw-fp-follow-terms-paging').hide();
	
	jQuery.post( WpwFpPublic.ajaxurl, data, function(response) {
		var newresponse = jQuery(response).filter('.wpw-fp-manage-follow-terms').html();
		jQuery('.wpw-fp-follow-terms-loader').hide();
		jQuery('.wpw-fp-manage-follow-terms').html(newresponse);
	});	
	return false;
}

// validation of email
function wpw_fp_valid_email(emailStr) {
	var checkTLD=1;
	var knownDomsPat=/^(com|net|org|edu|int|mil|gov|arpa|biz|aero|name|coop|info|pro|museum)$/;
	var emailPat=/^(.+)@(.+)$/;
	var specialChars="\\(\\)><@,;:\\\\\\\"\\.\\[\\]";
	var validChars="\[^\\s" + specialChars + "\]";
	var quotedUser="(\"[^\"]*\")";
	var ipDomainPat=/^\[(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})\]$/;
	var atom=validChars + '+';
	var word="(" + atom + "|" + quotedUser + ")";
	var userPat=new RegExp("^" + word + "(\\." + word + ")*$");
	var domainPat=new RegExp("^" + atom + "(\\." + atom +")*$");
	var matchArray=emailStr.match(emailPat);
	if (matchArray==null) {
		/* Email address seems incorrect (check @ and .'s) */
		return false;
	}
	var user=matchArray[1];
	var domain=matchArray[2];
	/* Start by checking that only basic ASCII characters are in the strings (0-127). */
	for (i=0; i<user.length; i++) {
		if (user.charCodeAt(i)>127) {
			/* Ths username contains invalid characters in e-mail address. */
			return false;
		}
	}
	for (i=0; i<domain.length; i++) {
		if (domain.charCodeAt(i)>127) {
			/* Ths domain name contains invalid characters in e-mail address. */
			return false;
		}
	}
	if (user.match(userPat)==null) {
		/* The username doesn't seem to be valid in e-mail address. */
		return false;
	}
	var IPArray=domain.match(ipDomainPat);
	if (IPArray!=null) {
		for (var i=1;i<=4;i++) {
			if (IPArray[i]>255) {
				/* Destination IP address is invalid! */
				return false;
	   		}
		}
		return true;
	}
	var atomPat=new RegExp("^" + atom + "$");
	var domArr=domain.split(".");
	var len=domArr.length;
	for (i=0;i<len;i++) {
		if (domArr[i].search(atomPat)==-1) {
			/* The domain name does not seem to be valid in e-mail address. */
			return false;
	   }	
	}
	if (checkTLD && domArr[domArr.length-1].length!=2 && 
		domArr[domArr.length-1].search(knownDomsPat)==-1) {
		/* The address must end in a well-known domain or two letter country. */
		return false;
	}

	if (len<2) {
		/* This e-mail address is missing a hostname! */
		return false;
	}	
	return true;
}
//********************* END of function for email-id validation  ****************************//