<?php

/**
 * Follow Author Listing
 * 
 * Template for follow authors Listing
 * 
 * Override this template by copying it to
 * yourtheme/follow-my-blog-post/subscribe-manage/follow-authors-listing/follow-authors-listing.php
 * 
 * @package Follow My Blog Post
 * @since 1.4
 **/

	global $wpw_fp_model, $wpw_fp_options;

	//model class
	$model = $wpw_fp_model;

	$prefix = WPW_FP_META_PREFIX;
	
	$page = isset( $_POST['paging'] ) ? $_POST['paging'] : '1';
	
	// get all custom post types
	$post_types = get_post_types( array( 'public' => true ), 'objects' );
	
	$followtext 	= $wpw_fp_options['authors_follow_buttons']['follow'];
	$followingtext 	= $wpw_fp_options['authors_follow_buttons']['following'];
	$unfollowtext 	= $wpw_fp_options['authors_follow_buttons']['unfollow'];
	
	$followtext 	= str_replace( '{author_name}', '', $followtext );
	$followingtext 	= str_replace( '{author_name}', '', $followingtext );
	$unfollowtext 	= str_replace( '{author_name}', '', $unfollowtext );
?>
<h3><?php esc_html_e( 'Authors I Follow', 'wpwfp' ); ?></h3>
<?php if( ! $disabled_actions ) {?>
<div class="wpw-fp-bulk-action-wrapper">
	<select class="wpw-fp-bulk-action">
		<option value=""><?php esc_html_e( 'Bulk Actions', 'wpwfp' ); ?></option>
		<option value="delete"><?php esc_html_e( 'Delete', 'wpwfp' ); ?></option>
	</select>
	<input type="button" class="wpw-fp-bulk-action-author-btn wpw-fp-btn" value="<?php esc_html_e( 'Apply', 'wpwfp' ); ?>" />
	<span class="wpw-fp-follow-loader wpw-fp-bulk-action-loader">
		<img src="<?php echo esc_url(WPW_FP_IMG_URL);?>/loader.gif"/>
	</span><!--.wpw-fp-follow-loader-->
</div>
<?php }?>
<input type="hidden" class="wpw-fp-bulk-paging" value="<?php echo $page; ?>" />
<div class="wpw-fp-clear" ></div>
<table class="wpw-fp-follow-author-table">
	<thead>
		<tr class="wpw-fp-follow-author-row-head">
				<?php 

				//do action to add header title of orders list before
				do_action('wpw_fp_follow_author_header_before');

				if( ! $disabled_actions ) {?>
				<th width="5%" class="wpw-fp-cb-authors">
					<input type="checkbox" class="wpw-fb-cb-authors wpw-fp-cb-authors-1" id="wpw_fp_cb_authors_1">
				</th>
				<?php }?>
				<th class="wpw-fp-picture" width="10%"><?php esc_html_e( 'Picture','wpwfp' );?></th>
				<th width="30%"><?php esc_html_e( 'Author Name','wpwfp' );?></th>
				<th width="25%"><?php esc_html_e( 'Followed Date','wpwfp' );?></th>
				<?php
				if( ! $disabled_actions ) {
					echo '<th width="25%">'. esc_html__( 'Actions','wpwfp' ) .'</th>';
				}

				//do action to add header title of orders list after
				do_action('wpw_fp_follow_author_header_after');
				?>
		</tr>
	</thead>
	
	<tbody>
	<?php
		foreach ( $followauthors as $followauthor ) {
			
			$authorid = isset( $followauthor['post_parent'] ) && !empty( $followauthor['post_parent'] ) ? $followauthor['post_parent'] : '';
			
			if( !empty( $authorid ) ) { // Check post parent is not empty
				
				// Get Follow author Name
				$author_data 	= get_user_by( 'id', $authorid);
    			$author_name 	= isset( $author_data->data->display_name ) ? $author_data->data->display_name : '';
    			$author_email 	= isset( $author_data->data->user_email ) ? $author_data->data->user_email : '';
				
				// Get Follow Date
				$followdate = $model->wpw_fp_get_date_format( $followauthor['post_date'] );

				if( empty( $author_data ) && empty( $author_name ) ) {
					$author_name = esc_html__( 'This user has been deleted.', 'wpwfp' );
				}
		?>
		<tr class="wpw-fp-follow-author-row-body">
			<?php 

			//do action to add row for orders list before
			do_action( 'wpw_fp_follow_author_row_before', $followauthor['ID'] ); 

			if( ! $disabled_actions ) {?>
			<td><input type="checkbox" class="wpw-fp-cb-author" value="<?php echo $followauthor['ID']; ?>" name="author[]"></td>
			<?php }?>
			<td class="wpw-fp-picture">
				<img src="<?php echo esc_url(apply_filters( 'wpw_fp_author_following_avatar', get_avatar_url( $author_email, 32 ), $author_email )); ?>" alt="Profile Photo" width="32">				
			</td>
			<td><?php echo apply_filters( 'wpw_fp_change_author_name',  $model->wpw_fp_short_content( $author_name ), $authorid ); ?></td>
			<td><?php echo $followdate;?></td>
			<?php if( ! $disabled_actions ) {?>
			<td>
				<?php
					$args = array(
										'author_id'			=> $authorid,
										'current_post_id'	=> $followauthor['ID'],
										'follow_message'	=> '',
										'follow_buttons'	=> array(
																			'follow' 	=> trim( $followtext ),
																			'following' => trim( $followingtext ),
																			'unfollow' 	=> trim( $unfollowtext ),
																		),
									);
					do_action( 'wpw_fp_follow_author', $args );
				?>
			</td>
			<?php 
			}

			//do action to add row for orders list after
			do_action( 'wpw_fp_follow_author_row_after', $followauthor['ID'] ); ?>
		</tr>
<?php	} } ?>
	</tbody>
	<tfoot>
		<tr class="wpw-fp-follow-author-row-foot">
			<?php 

			//do action to add row in footer before
			do_action('wpw_fp_follow_author_footer_before');

			if( ! $disabled_actions ) {?>
			<th class="wpw-fp-cb-authors">
				<input type="checkbox" class="wpw-fb-cb-authors wpw-fp-cb-authors-2" id="wpw_fp_cb_authors_2">
			</th>
			<?php }?>
			<th class="wpw-fp-picture"><?php esc_html_e( 'Picture','wpwfp' );?></th>
			<th><?php esc_html_e( 'Author Name','wpwfp' );?></th>
			<th><?php esc_html_e( 'Followed Date','wpwfp' );?></th>
			<?php
			if( ! $disabled_actions ) {
				echo '<th>'. esc_html__( 'Actions','wpwfp' ) .'</th>';
			}

			//do action to add row in footer after
			do_action('wpw_fp_follow_author_footer_after');
			?>
		</tr>
	</tfoot>
</table>

<div class="wpw-fp-paging wpw-fp-follow-authors-paging">
	<div id="wpw-fp-tablenav-pages" class="wpw-fp-tablenav-pages">
		<?php echo $paging->getOutput(); ?>
	</div><!--.wpw-fp-tablenav-pages-->
</div><!--.wpw-fp-paging-->
<div class="wpw-fp-follow-loader wpw-fp-follow-authors-loader">
	<img src="<?php echo esc_url(WPW_FP_IMG_URL);?>/loader.gif"/>
</div><!--.wpw-fp-sales-loader-->